#ifndef NEXTMEX_H_
#define NEXTMEX_H_
#include "cprolog.h"

/*----nextmex.h--Mod 21.02.95:  Address for Ts,Stat,Vers --*/
/*----defines NETKEY structure for encapsulated calls------*/
typedef struct {
   char Eqpname[16];             /* points to server in db */
   char Property[32]; /* property (i.e. keyword) at server */
   short format;                  /* CF_CODE for data type */
   short no_el;              /* # of elements (init=total) */
   short EqNo;                    /* first element to send */
   short Ret_Code;                   /* 0=ok, else error # */
   int TimeStamp;              /* 4 Byte Int for timestamp */
   short Status;                       /* data status word */
   short Version;             /* version # for data header */
   void * data;                              /* data array */
   void (*fcn)(char *,int);      /*callback for async calls*/
   char DevName[16];          /* device name (re: keyword) */
} NETKEY;

/* MEX data structure used in MEX servers: */
typedef struct mexData
{
  char   keyword[32];
  time_t timestamp;
  short  format;
  unsigned short size;
  short (*fcn)(float *data,unsigned short size,short index); /* calling function */
  struct mexData *next;
} MEXDATA;

int LinkNextMex(NETKEY *key,int PollRate,void (*function)(char *,int),short mode);
int LinkNetmex(NETKEY *key,int PollRate,void (*function)(char *,int),
               short mode,void *buf,int buffmt,int buflen);
int NextMex(NETKEY* key);
int getNetmex(NETKEY* key,void *buf,int buffmt,int buflen);
int InitPack(char *Name, NETKEY* key);
int NextPack(char *Name);
int RegisterKeyword(char *keyword,short format,unsigned short size,
                    short (*fcn)(float *,unsigned short,short));
int RegisterNetmexKeywords(void);
void setKeywordRefreshRoutine(void (*fcn)(void),int rate); /* server background routine */
int initNetmexServer(void);

#define T_INIT  0              /* for header inits */
#define ST_INI -1
#define RC_INI -1
                                  /* first try for */
#define data_ok         0    /* defines for Status */
#define stale_data      1            /* start with */
#define header_mismatch 16384       /* maskable #s */

#define FlushNextMex(i) FlushLinks(i)

#endif /* NEXTMEX_H_ */
