#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "toolkit.h"

extern int rpPollingRate;
extern int gTruncateDeviceNames;
int rpPreSystemInit(char *tgtContext,char *tgtServer);
int rpPostSystemInit(char *tgtContext,char *tgtServer);
int main(int argc, char *argv[])
{
  int cc;
  char cntxt[32],devsrv[32];
  switch (argc)
  {           
    case 5:
      gTruncateDeviceNames = atoi(argv[4]);
    case 4:
      rpPollingRate = atoi(argv[3]);
    case 3:   
      strncpy(cntxt,argv[1],16);
      strncpy(devsrv,argv[2],16);
      break;
    default:
      printf("Usage: tineRepeater <context> <device server>\n");
      printf("e.g.\n\ttineRepeater HERA HEEBLM\n\n");
      exit(1);
  }
  printf("Server running (debug level %d)\n",NGdebug);

  MaxRPCTransportSize = 1024*64*16;
  FeclogDepth = 500;
# ifdef MULTITHREADED
  useMultiThreadedEquipmentFunctions = FALSE;
  useMultiThreadedBackgroundTasks = FALSE;
# endif
  rpPreSystemInit(cntxt,devsrv);
  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }
  rpPostSystemInit(cntxt,devsrv);
  for (;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
